<?php
error_reporting(1);

class ControllerSaleSmsSending extends Controller {
	private $error = array();
    private $api_gateway;
    private $api_stat;
    private $api_account;
    private $api_addressbook;
    private $settings;
    
	public function __construct($registry) {
		parent::__construct($registry);
        
        // require_once(modification(DIR_SYSTEM . 'engine/action.php'));
        require_once (DIR_APPLICATION . 'libs/config.php');
        require_once (DIR_APPLICATION . 'libs/Addressbook.php');
        require_once (DIR_APPLICATION . 'libs/Exceptions.php');
        require_once (DIR_APPLICATION . 'libs/Account.php');
        require_once (DIR_APPLICATION . 'libs/Stat.php');
		
		$this->load->model('sale/sms_sending');
        $settings = $this->model_sale_sms_sending->getSettings();
		
        if (!isset($settings['private_key']) || !isset($settings['public_key']) || !isset($settings['sms_alias']) || $settings['private_key'] == '' || $settings['public_key'] == '' || $settings['sms_alias'] == '') {
            $this->language->load('sale/sms_sending');
			$this->data['error_warning'] = $this->language->get('error_warning');
		} else {
			$this->data['error_warning'] = '';
            $sms_key_public = $settings['public_key'];
            $sms_key_private = $settings['private_key'];
            $this->settings = $settings;
		}
        
    	if (isset($sms_key_private)
    		AND isset($sms_key_public)) {
            $this->api_gateway = new APISMS($sms_key_private, $sms_key_public, $URL_GAREWAY);
            $this->api_stat = new Stat ($this->api_gateway);
            $this->api_account =new Account($this->api_gateway);
            $this->api_addressbook = new Addressbook($this->api_gateway);
    	}
	}
	 
	public function index() {
        $this->load->model('sale/sms_sending');
        $this->language->load('sale/sms_sending');
        $settings = $this->settings;
        
        // get user getUserBalance
        if ($this->data['error_warning'] == ''){
            $res = $this->api_account->getUserBalance();
            if (isset($res["error"])) {
                $this->data['error_warning'] = $this->language->get('error_start'). $res["error"] . '; code: ' .$res["code"]."<br>";
            }
        }
        
        /*start Customer Groups*/
        $customer_groups = $this->model_sale_sms_sending->getCustomerGroups();
        
        foreach ($customer_groups as $group) {
			$this->data['customer_groups'][] = array(
				'customer_group_id' => $group['customer_group_id'],
				'name'              => $group['name'] . (($group['customer_group_id'] == $this->config->get('config_customer_group_id')) ? $this->language->get('text_default') : null)
			);
		}
                /*end Customer Groups*/  
		$this->document->setTitle($this->language->get('heading_title'));
        
		$this->data['settings_link'] = $this->url->link('sale/sms_sending/settings', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['settings_label'] = $this->language->get('settings_label');
        
		$this->data['heading_title'] = $this->language->get('heading_title');
        if (isset($res)) {
            $this->data['balance'] = ! isset($res["error"]) ? $res["result"]["balance_currency"].' '.$res["result"]["currency"]:$this->language->get('error_settings');
        } else {
            $this->data['balance'] = $this->language->get('error_settings');
        }
        $this->data['alias'] = isset($settings['sms_alias'])?$settings['sms_alias']:$this->language->get('error_settings');
		$this->data['text_balance'] = $this->language->get('text_balance');
        $this->data['text_alias'] = $this->language->get('text_alias');
        $this->data['text_datetime'] = $this->language->get('text_datetime');
        $this->data['text_instantly'] = $this->language->get('text_instantly');
        $this->data['text_start_at'] = $this->language->get('text_start_at');
        $this->data['text_translit'] = $this->language->get('text_translit');
        $this->data['text_message'] = $this->language->get('text_message');
        $this->data['text_symbols'] = $this->language->get('text_symbols');
		$this->data['entry_message'] = $this->language->get('entry_message');
        $this->data['entry_store'] = $this->language->get('entry_store');
		$this->data['entry_to'] = $this->language->get('entry_to');
		$this->data['entry_customer_group'] = $this->language->get('entry_customer_group');
		$this->data['entry_customer'] = $this->language->get('entry_customer');
		$this->data['button_send'] = $this->language->get('button_send');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
        $this->data['button_ignore'] = $this->language->get('button_ignore');
        $this->data['button_correct'] = $this->language->get('button_correct');
		$this->data['error_settings'] = $this->language->get('error_settings');
		$this->data['token'] = $this->session->data['token'];
  		$this->data['breadcrumbs'] = array();
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('sale/sms_sending', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);	
        $this->data['cancel'] = $this->url->link('sale/sms_sending', 'token=' . $this->session->data['token'], 'SSL');
        $this->data['correct'] = $this->url->link('sale/customer', 'token=' . $this->session->data['token'], 'SSL');
		$this->load->model('setting/store');
		$this->data['stores'] = $this->model_setting_store->getStores();
		$this->load->model('sale/customer_group');	
		$this->data['customer_groups'] = $this->model_sale_customer_group->getCustomerGroups(0);	
		$this->template = 'sale/sms_sending.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
		$this->response->setOutput($this->render());
	}
	
	public function settings() {
        
        $this->language->load('sale/sms_sending');
        
        $this->load->model('sale/sms_sending');
        $this->data['token'] = $this->session->data['token'];

        $this->document->setTitle($this->language->get('heading_title'));
        
        $this->data['heading_title'] = $this->language->get('heading_title');
        
        $this->data['button_send'] = $this->language->get('save');
        $this->data['settings'] = $this->settings;
        
        
        $this->data['sms_alias_label'] = $this->language->get('sms_alias');
        $this->data['public_key_label'] = $this->language->get('public_key');
        $this->data['private_key_label'] = $this->language->get('private_key');
        
        $this->data['sms_alias'] = $this->settings['sms_alias'];
        $this->data['public_key'] = $this->settings['public_key'];
        $this->data['private_key'] = $this->settings['private_key'];
        
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('sale/sms_sending_settings', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
        
        
		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if (!$this->user->hasPermission('modify', 'sale/sms_sending')) {
				$json['error']['warning'] = $this->language->get('error_permission');
			}

            if ( ! isset($json['error'])) {
                $this->load->model('sale/sms_sending');
                $res = $this->model_sale_sms_sending->setSettings($this->request->post['sms_alias'], $this->request->post['public_key'], $this->request->post['private_key']); 
                if ($res) {
                    $this->data['success'] = $this->language->get('text_settings_success');
                } else {
                    $this->data['error']['warning'] = $this->language->get('text_settings_error');
                }
            }
            die(json_encode($this->data));
        }
        
        $this->template = 'sale/sms_sending_settings.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
        $this->response->setOutput($this->render());
    }
    
	public function send() {
		$this->language->load('sale/sms_sending');
        $this->load->model('sale/sms_sending');
        
        $error_start = $this->language->get('error_start');
        
        $settings = $this->settings;
		$json = array();
		if ($this->request->server['REQUEST_METHOD'] == 'POST') {
			if (!$this->user->hasPermission('modify', 'sale/sms_sending')) {
				$json['error']['warning'] = $this->language->get('error_permission');
			}
			if (!$this->request->post['message']) {
				$json['error']['message'] = $this->language->get('error_message');
			}
            $to_info = $this->model_sale_sms_sending->getCustomers($this->request->post['to']);
            $error_format = '';
            if(!$to_info){
                $json['error']['customers'] = $this->language->get('error_customers');
            }else {
                if($this->request->post['ignore'] == '0'){
                    foreach ($to_info as $result) {
                        if(!preg_match("/[3][8][0][0-9]{9}$/i",$result['telephone'])){
                            $error_format .= $result['CONCAT(firstname, \' \',lastname)'].' - '.$result['telephone']."</br>";
                        }
                    }
                    if($error_format !='' ){
                        $json['error']['format'] = $this->language->get('error_phones').$error_format;
                    }
                }
            }
			
			if (!$json) {
                            
                if($this->request->post['timesend'] == '1') {
                    $timesend = '';
                }else{
                    $timesend = $this->request->post['date'];
                }
                            
                if ($this->request->post['translit_checked'] == 1){
                    $replace=array(
                        "'"=>"","`"=>"",
                        "а"=>"a","А"=>"a",
                        "б"=>"b","Б"=>"b",
                        "в"=>"v","В"=>"v",
                        "г"=>"g","Г"=>"g",
                        "д"=>"d","Д"=>"d",
                        "е"=>"e","Е"=>"e",
                        "ж"=>"zh","Ж"=>"zh",
                        "з"=>"z","З"=>"z",
                        "и"=>"i","И"=>"i",
                        "й"=>"y","Й"=>"y",
                        "к"=>"k","К"=>"k",
                        "л"=>"l","Л"=>"l",
                        "м"=>"m","М"=>"m",
                        "н"=>"n","Н"=>"n",
                        "о"=>"o","О"=>"o",
                        "п"=>"p","П"=>"p",
                        "р"=>"r","Р"=>"r",
                        "с"=>"s","С"=>"s",
                        "т"=>"t","Т"=>"t",
                        "у"=>"u","У"=>"u",
                        "ф"=>"f","Ф"=>"f",
                        "х"=>"h","Х"=>"h",
                        "ц"=>"c","Ц"=>"c",
                        "ч"=>"ch","Ч"=>"ch",
                        "ш"=>"sh","Ш"=>"sh",
                        "щ"=>"sch","Щ"=>"sch",
                        "ъ"=>"","Ъ"=>"",
                        "ы"=>"y","Ы"=>"y",
                        "ь"=>"","Ь"=>"",
                        "э"=>"e","Э"=>"e",
                        "ю"=>"yu","Ю"=>"yu",
                        "я"=>"ya","Я"=>"ya",
                        "і"=>"i","І"=>"i",
                        "ї"=>"yi","Ї"=>"yi",
                        "є"=>"e","Є"=>"e"
                    );
                    $this->request->post['message']=iconv("UTF-8","UTF-8//IGNORE",strtr($this->request->post['message'],$replace));
                }
                
                //addAddressbook
                $res = $this->api_addressbook->addAddressbook($this->request->post['to']);
                //Проверяем успешность операции
                if (isset($res["error"])) {
                    $json['error']['message'] = $error_start. $res["error"] . '; code: ' .$res["code"];
                } else {
                    //Получаем ИД книги
                    $book_id = $res["result"]["addressbook_id"];
                }

                if($book_id) {
                    //addPhoneToAddressBook
                    foreach ($to_info as $info) {                        
                        $res = $this->api_addressbook->addPhoneToAddressBook($book_id, $info['telephone'], $info['CONCAT(firstname, \' \',lastname)']);
                        if (isset($res["error"])) {
                            $json['error']['message'] = $error_start. $res["error"] . '; code: ' .$res["code"]."<br>";
                        }
                    }
                    
                    // sender text list_id datetime batch batchinterval sms_lifetime control_phone
                    $res = $this->api_stat->createCampaign($settings["sms_alias"], $this->request->post['message'], $book_id, $timesend, 0, 0, 0);
                    
                    if (isset($res["error"])) {
                        $json['error']['message'] = $error_start. $res["error"] . '; code: ' .$res["code"]."<br>";
                    } else {
                        $campaign_id = $res["result"]["id"];
                    }
                    
                    if ($campaign_id){
                        $res = $this->api_stat->getCampaignInfo($campaign_id);
                        
                        if (isset($res["error"])) {
                            $json['error']['message'] =  $error_start. $res["error"] . '; code: ' .$res["code"]."<br>";
                        } else {
                            $campinf_status_code = $res["result"]["status"];
                            $campinf_status = array(
                                $this->language->get('status_queue'),
                                $this->language->get('status_not_money'),
                                $this->language->get('status_sending'),
                                $this->language->get('status_sent'),
                                $this->language->get('status_no_recipients'),
                                $this->language->get('status_partially_sent'),
                                $this->language->get('status_spam'),
                                $this->language->get('status_incorrect_sender'),
                                $this->language->get('status_paused'),
                                $this->language->get('status_scheduled'),
                                $this->language->get('status_premoderation'),
                            );
                            if(array_key_exists($campinf_status_code, $campinf_status)){
                                $this->data['campinf_status'] = $campinf_status[$campinf_status_code];
                                $json['success'] = sprintf($this->language->get('text_success'), $this->data['campinf_status']);
                                //$this->data['success'] = sprintf($this->language->get('text_success'), $this->data['campinf_status']);
                            }  
                        }
                    } 
                    $res = $this->api_addressbook->delAddressbook($book_id);
                }
			}
		}
		$this->response->setOutput(json_encode($json));
	}
}
?>